326b77e49c0d5b48989b71c102aea2a0a0cb883a
[xfstests-dev.git] / 112
1 #! /bin/sh
2 #
3 #-----------------------------------------------------------------------
4 # Copyright (c) 2005 Silicon Graphics, Inc.  All Rights Reserved.
5 #
6 # This program is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU General Public License as
8 # published by the Free Software Foundation.
9 #
10 # This program is distributed in the hope that it would be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write the Free Software Foundation,
17 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
18 #
19 #-----------------------------------------------------------------------
20 #
21 # FS QA Test No. 112
22 #
23 # fsx (AIO variant, based on 075)
24 #
25 # creator
26 owner=nathans@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=0        # success is the default!
34 trap "_cleanup; exit \$status" 0 1 2 3 15
35
36 _cleanup()
37 {
38     cd /
39     rm -rf $testdir/fsx.* $tmp.*
40     _cleanup_testdir
41 }
42
43 # get standard environment, filters and checks
44 . ./common.rc
45 . ./common.filter
46
47 _do_test()
48 {
49     _n="$1"
50     _param="$2"
51
52     out=$testdir/fsx
53     rm -rf $out
54     if ! mkdir $out
55     then
56         echo "    failed to mkdir $out"
57         status=1
58         exit
59     fi
60
61     _filter_param=`echo "$_param" | sed\
62         -e 's/-N [0-9][0-9]*/-N numops/' \
63         -e 's/-l [0-9][0-9]*/-l filelen/'`
64
65     echo ""
66     echo "-----------------------------------------------"
67     echo "fsx.$_n : $_filter_param"
68     echo "-----------------------------------------------"
69
70     # This cd and use of -P gets full debug on $here (not TEST_DEV)
71     cd $out
72     if ! $here/ltp/fsx $_param -P $here $seq.$_n >/dev/null
73     then
74         echo "    fsx ($_param) returned $? - see $seq.$_n.full"
75         mv $seq.$_n.fsxlog $here/$seq.$_n.full
76         status=1
77         exit
78     fi
79
80     cd $here
81     _check_test_fs
82 }
83
84 _usage()
85 {
86     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
87 }
88
89 _process_args()
90 {
91     while getopts "l:n:N:?" c $@
92     do
93         case $c
94         in
95             l)
96                 filelen=$OPTARG
97                 param_type="$param_type, overidde -l"
98                 ;;
99             N)
100                 numops2=$OPTARG
101                 param_type="$param_type, overidde -N"
102                 ;;
103             n)
104                 numops1=$OPTARG
105                 param_type="$param_type, overidde -n"
106                 ;;
107             ?)
108                 _usage
109                 exit    
110                 ;;
111         esac
112     done
113 }
114
115
116 # real QA test starts here
117 _supported_fs xfs
118 _supported_os Linux
119
120 [ -x $here/ltp/aio-stress ] || \
121         _notrun "fsx not built with AIO for this platform"
122
123 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
124 filelen=$size10
125 numops1=1000
126 numops2=10000
127
128 # can override the params here
129 _process_args "$@"
130
131 echo "Params are for $param_type" >>$seq.full
132 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seq.full
133
134 _setup_testdir
135
136 rm -f $here/$seq.full
137 echo "brevity is wit..."
138
139 _check_test_fs
140
141 # Options:
142 # -d: debug output for all operations
143 # -l flen: the upper bound on file size (default 262144)
144 # -o oplen: the upper bound on operation size
145 # -N numops: total # operations to do (default infinity)
146 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
147 # -S seed: for random # generator (default 1) 0 gets timestamp
148 # -x: pre-allocate file space, exercising unwritten extents
149 # -A: use the AIO system calls
150
151 _do_test 0 "-A -d -N $numops1 -S 0"
152 _do_test 1 "-A -d -N $numops1 -S 0 -x"
153 _do_test 2 "-A -d -N $numops2 -l $filelen -S 0"
154 _do_test 3 "-A -d -N $numops2 -l $filelen -S 0 -x"
155
156 rm -f $seq.*.fsx{good,log}
157 exit 0